<template>
<Modal v-if="data.showModal" @close="toggleModal"/>
<div>
</div>
  <div class="container">
    <h1>How Fast <span class="username">{{data.username}}</span> Find and Slap The Corruptor (Maling Uang Rakyat)</h1>
    <div class="wrapwarning">
      <p>The corruptor will only show inside the "border areas" in randomly times and places</p>
    </div>
    <div class="wrapbutton">
      <button @click="start" :disabled="data.isPlaying" :style="data.isPlaying ? data.userNotAllowed : data.userAllowed ">
      {{ data.isPlaying ? 'Search..' :'Play'}}
      </button>
    </div>
    <Result v-if="data.showResult" :score="data.score" :title="data.title"/>
    <div class="container-wrap"> 
      <Block v-if="data.isPlaying" :delay="data.delay" @end="endGame"/>
    </div>
  </div>
</template>
<script>
import { onMounted, onUpdated , reactive , ref } from "vue"
import Block from "./Block.vue"
import Modal from "./Modal.vue"
import Result from "./Result.vue"
import {createRanking , getRankById  } from "../firebase"
import { getTitle  }from "../utils.js"
export default {
  components:{Block, Result, Modal},
  setup() {
    const lastScore = ref(null)
    const lastTitle = ref(null) 
    const data = reactive({
      username : '' ,
      showModal: true,
      isPlaying : false,
      showResult : false,
      delay : null,
      score : null,
      title : null,
      userAllowed : {
        cursor : 'pointer',
        backgroundColor : "#059669",
      },
      userNotAllowed : {
        cursor : 'not-allowed',
        backgroundColor : "#B91C1C",
      }
    })

    onMounted(async()=>{
      if(localStorage.username){
        const name = await localStorage.username
        data.username = name
        data.showModal = false
      }
    })

    const start = () => {
      data.delay = 2000 + Math.random() * 5000;
      data.isPlaying = true
      data.showResult = false
    }
      const saveToFirebase = async () => {
          const rank = {
          name : data.username,
          title : lastScore.value === null ? getTitle(data.score) : lastScore.value > data.score ? getTitle(data.score) : lastTitle.value ,
          score : lastScore.value === null ? data.score : lastScore.value > data.score ? data.score: lastScore.value,
        }
        await createRanking(rank)
      }

    const endGame = (reactionTime) => {
      data.score = reactionTime
      data.isPlaying = false
      data.showResult = true
      saveToFirebase()
    }


    onUpdated(async()=>{
      data.username =localStorage.username
        const userById =await getRankById(localStorage.username) 
        lastScore.value = userById.score
        lastTitle.value = userById.title
    })

    const toggleModal = () =>  data.showModal = false

    return {saveToFirebase , data , toggleModal , endGame , start , lastScore , lastTitle}
  },

  // mounted() {
  //   if(localStorage.username){
  //     this.username = localStorage.username
  //     this.showModal = false
  //   }
  //     this.unsubscribe = getRankingById(this.username) 
  // },
  // beforeMount() {
  //   this.unsubscribe();
  // },

  
}
</script>

<style>
*{
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  margin: 0;
  padding: 0;
}
.container{
  height: 95vh;
  padding: 20px;
  display : flex;
  flex-direction: column;
  background: #F4F4F5;
}
.container h1{
  color: #2c3e50;
  font-size:1.6rem
}
.container h1 .username{
  background: #FF4E19;
  padding: 3px 20px;
  border : 4px solid #2c3e50;
  border-radius: 50px;
  color : #F4F4F5;
  font-size:17pt;
}

.wrapbutton{
  padding : 20px;
}
.container button{
  padding: 16px 0px;
  border-radius: 5px;
  font-family: Roboto;
  font-weight: 500;
  width : 150px;
  font-size: 16px;
  line-height: 1;
  color: white;
  background: none;
  border: none;
  outline: none;
  overflow: hidden;
  box-shadow: 0px 8px 15px rgba(233, 62, 62, 0.1);
}

.container-wrap{
  border:3px dashed #FFB74F ;
  z-index: 1;
  height: 50vh;
  width: 60%;
  margin: auto;
  position: relative;
  border-radius : 15px
}

.container .wrapwarning {
    margin : auto;
    padding: 10px 15px;
    transition:0.5s;
    cursor:pointer;
    background-color: rgba(220, 16, 1, 0.041);
}

.container .wrapwarning{
  border-left: 10px solid #FFB74F;
  border-right: 10px solid #FFB74F;
  border-radius: 5px;
}

.wrapwarning p{
  color : #FF4E19
}
@media only screen and (max-width: 600px) {
  .container h1{
    font-size: 19pt;
  }
  .container .wrapwarning{
    margin-top: 10px;
  }
  .container-wrap{
    width: 100%;
  }
.container h1 .username{
  background: #FF4E19;
  padding: 3px 20px;
  border : 4px solid #2c3e50;
  border-radius: 50px;
  color : #F4F4F5;
  font-size:12pt;
  line-height: 2;
}
}
</style>
